<?php
$SignKey = md5(file_get_contents(__DIR__ . '/sign.key') . '60UdBCkh7cRQ4LMuCQ07eYaXFN8o39zO');

vf();

function CCDef($clientIP, $rti = 0.5, $nac = 5, $abf = 1800, $amf = 30, $aml = 45)
{
	$fileHandle = fopen(__DIR__ . '/bna.vf', 'r');
	$file = '';
	$flag = false;
	while(!feof($fileHandle))
	{
		if(($buffer = trim(fgets($fileHandle))) != '')
		{
			$buffer = explode(',', $buffer);
			if(time() <= $buffer[1] + $abf)
			{
				$file .= $buffer[0] . ',' . $buffer[1] . "\r\n";
				if((!$flag) && $clientIP == $buffer[0])
				{
					PrintWarningPage($clientIP, ' 网络地址预过滤(自动)', '/pages/ipaddblocked.php');
					$flag = true;
				}
			}
		}
	}
	fclose($fileHandle);
	$fileHandle = fopen(__DIR__ . '/bna.vf', 'w');
	fwrite($fileHandle, $file);
	fclose($fileHandle);
	if($flag)
	{
		die();
	}
	$fileHandle = fopen(__DIR__ . '/mna.vf', 'r');
	$file = '';
	$flag = false;
	while(!feof($fileHandle))
	{
		if(($buffer = trim(fgets($fileHandle))) != '')
		{
			$buffer = explode(',', $buffer);
			if(time() <= $buffer[1] + $amf)
			{
				if($clientIP == $buffer[0])
				{
					$file .= $buffer[0] . ',' . $buffer[1] . ',' . ++$buffer[2] . "\r\n";
					$flag = true;
					if($buffer[2] >= $aml)
					{
						$fileHandle2 = fopen(__DIR__ . '/bna.vf', 'a');
						fwrite($fileHandle2, $buffer[0] . ',' . time() . "\r\n");
						fclose($fileHandle2);
					}
				}
				else
				{
					$file .= $buffer[0] . ',' . $buffer[1] . ',' . $buffer[2] . "\r\n";
				}
			}
		}
	}
	fclose($fileHandle);
	$fileHandle = fopen(__DIR__ . '/mna.vf', 'w');
	fwrite($fileHandle, $file);
	fclose($fileHandle);
	$time = microtime(true);
	$fileHandle = fopen(__DIR__ . '/lrt.vf', 'r+');
	$lastRequest = fgets($fileHandle, 4096);
	rewind($fileHandle);
	fwrite($fileHandle, $time);
	fclose($fileHandle);
	$fileHandle = fopen(__DIR__ . '/nac.vf', 'r+');
	if(($interval = $time - $lastRequest) < $rti)
	{
		if(!$flag)
		{
			$fileHandle2 = fopen(__DIR__ . '/mna.vf', 'a');
			fwrite($fileHandle2, $clientIP . ',' . time() . ',' . "1\r\n");
			fclose($fileHandle2);
		}
		if(($times = fgets($fileHandle, 4096)) > 0)
		{
			rewind($fileHandle);
			fwrite($fileHandle, $times - 1);
		}
		else
		{
			fclose($fileHandle);
			return true;
		}
	}
	else if(($times = fgets($fileHandle, 4096)) < $nac)
	{
		rewind($fileHandle);
		$times = ($newValue = ($times + (int)($interval / 5) + 1)) > $nac ? $nac : $newValue;
		fwrite($fileHandle, $times);
	}
	fclose($fileHandle);
	return false;
}

function vf()
{
	$clientIP = GetRealIPAddr();
	if(preg_match('/,/', $clientIP))
	{
		$clientIP = substr($clientIP, 0, strpos($clientIP, ','));
	}
	$bannedRegions = array();
	$arrIndex = 0;
	$fileHandle = fopen(__DIR__ . '/blacklist.cfg','r');
	$tmp=array();
	while(!feof($fileHandle))
	{
		$buffer = trim(fgets($fileHandle, 4096));
		if(preg_match('/^[^,]*,[^,]*$/', $buffer) && preg_match('/' . substr($buffer, 0, strpos($buffer, ',')) . '/', $clientIP))
		{
			SendForbiddenCookieAndPrintWarningPageAndDie($clientIP, ' 网络地址预过滤(预设)', substr($buffer, strpos($buffer, ',') + 1));
		}
		else if($buffer != '' && preg_match('/^[^,]*,[^,]*$/', $buffer) == false)
		{
			preg_match('/([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*)$/', $buffer, $tmp);
			$bannedRegions[$arrIndex++] = $tmp;
		}
    }
	fclose($fileHandle);
	if(CCDef($clientIP))
	{
		header('HTTP/1.1 503 Service Unavailable');
		die('<h1>Service Unavailable</h1>');
	}
	global $SignKey;
	if($_COOKIE['blocked'] == 'false')
	{
		if(time() - $_COOKIE['sign_t'] <= 3600 && md5($_COOKIE['sign_t'] . $clientIP . $SignKey) == $_COOKIE['sign'])
		{
			$fileHandle = fopen(__DIR__ . '/logs/' . date('Ymd') . '.log','a');
			fwrite($fileHandle, date('Y-m-d H:i:s') . ' - Allow ' . $clientIP . ' (重复请求)' . "\r\n");
			fclose($fileHandle);
			return;
		}
	}
	else if($_COOKIE['blocked'] == 'true')
	{
		if(time() - $_COOKIE['sign_t'] <= 3600 && md5($_COOKIE['sign_t'] . $clientIP . $_COOKIE['vf_wnpage'] . $SignKey) == $_COOKIE['sign'])
		{
			PrintWarningPage($clientIP, ' (重复请求)', $_COOKIE['vf_wnpage']);
			die();
		}
	}
	$IPInfo = file_get_contents('http://ip.taobao.com/service/getIpInfo.php?ip=' . $clientIP);
	$IPInfo = UnicodeDecode($IPInfo);
	if(!preg_match('/code1data/', $IPInfo))
	{
		preg_match('/datacountry(.*)country_id.*area.*area_id.*region(.*)region_id.*city(.*)city_id.*county(.*)county_id.*isp(.*)isp_id/', $IPInfo, $IPInfo);
		$IPInformation = $IPInfo[1] . $IPInfo[2] . $IPInfo[3] . $IPInfo[4] . $IPInfo[5];
		foreach($bannedRegions as $region)
		{
			for($i = 1; $i<=5; $i++)
			{
				if(trim($region[$i]) == '')
				{
					$region[$i] = '.*';
				}
				if(!preg_match('/' . $region[$i] . '/', $IPInfo[$i]))
				{
					break;
				}
				else if($i == 5)
				{
					SendForbiddenCookieAndPrintWarningPageAndDie($clientIP, ' ' . $IPInformation, $region[6]);
				}
			}
		}
		$fileHandle = fopen(__DIR__ . '/logs/' . date('Ymd') . '.log','a');
		fwrite($fileHandle, date('Y-m-d H:i:s') . ' - Allow ' . $clientIP . ' ' . $IPInformation . "\r\n");
		fclose($fileHandle);
	}
	else
	{
		$fileHandle = fopen(__DIR__ . '/logs/' . date('Ymd') . '.log','a');
		fwrite($fileHandle, date('Y-m-d H:i:s') . ' - Error ' . $clientIP . "\r\n");
		fclose($fileHandle);
	}
	SendPassedCookies($clientIP);
}

function SendPassedCookies($IP)
{
	global $SignKey;
	$time = time();
	setcookie('blocked', 'false', $time + 3600);
	setcookie('sign_t', $time, $time + 3600);
	setcookie('vf_wnpage', '', $time + 3600);
	setcookie('sign', md5($time . $IP . $SignKey), $time + 3600);
}

function SendForbiddenCookieAndPrintWarningPageAndDie($IP, $IPInfo, $customWarningPageLocation)
{
	global $SignKey;
	$time = time();
	setcookie('blocked', 'true', $time + 3600);
	setcookie('sign_t', $time, $time + 3600);
	setcookie('sign', md5($time . $IP . $customWarningPageLocation . $SignKey), $time + 3600);
	if($customWarningPageLocation != '')
	{
		setcookie('vf_wnpage', $customWarningPageLocation, $time + 3600);
	}
	else
	{
		setcookie('vf_wnpage', '', $time + 3600);
	}
	PrintWarningPage($IP, $IPInfo, $customWarningPageLocation);
	die();
}

function PrintWarningPage($IP, $IPInfo, $customWarningPageLocation)
{
	if($IPInfo != '')
	{
		$fileHandle = fopen(__DIR__ . '/logs/' . date('Ymd') . '.log','a');
		fwrite($fileHandle, date('Y-m-d H:i:s') . ' - Deny  ' . $IP . $IPInfo . "\r\n");
		fclose($fileHandle);
	}
	if($customWarningPageLocation != '')
	{
		include __DIR__ . $customWarningPageLocation;
		die();
	}
	include __DIR__ . "/pages/templete.php";
}

function GetRealIPAddr()
{
	if (!empty($_SERVER['HTTP_CLIENT_IP']))
	{
		$ip = $_SERVER['HTTP_CLIENT_IP'];
	}
	elseif(!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
	{
		$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
	}
	else
	{
		$ip = $_SERVER['REMOTE_ADDR'];
	}
	return $ip;
}

function UnicodeDecode($name)
{
	$pattern = '/([\w]+)|(\\\u([\w]{4}))/i';
	preg_match_all($pattern, $name, $matches);
	if(!empty($matches))
	{
		$name = '';
		for ($j = 0; $j < count($matches[0]); $j++)
		{
			$str = $matches[0][$j];
			if (strpos($str, '\\u') === 0)
			{
				$code = base_convert(substr($str, 2, 2), 16, 10);
				$code2 = base_convert(substr($str, 4), 16, 10);
				$c = chr($code).chr($code2);
				$c = iconv('UCS-2', 'UTF-8', $c);
				$name .= $c;
			}
			else
			{
				$name .= $str;
			}
		}
	}
	return $name;
}

?>